searchNodes=[{"doc":"Accepts data with different shapes and changes them to an expected shape, such as switching keys in a map to camel case, or all string keys to atom keys, etc. Three primary sections: Transmogrifier — convert maps and list keys and values. As — Simple data polymorphic conversions (as_atom/1) for example. Case and Path conversions (camelcase/snakecase, etc) — see below","ref":"Transmogrify.html","title":"Transmogrify","type":"module"},{"doc":"See Transmogrify.Camelcase.convert/1 .","ref":"Transmogrify.html#camelcase/1","title":"Transmogrify.camelcase/1","type":"function"},{"doc":"See Transmogrify.Modulename.convert/1 .","ref":"Transmogrify.html#modulename/1","title":"Transmogrify.modulename/1","type":"function"},{"doc":"See Transmogrify.Pascalcase.convert/1 .","ref":"Transmogrify.html#pascalcase/1","title":"Transmogrify.pascalcase/1","type":"function"},{"doc":"See Transmogrify.Pathname.convert/1 .","ref":"Transmogrify.html#pathname/1","title":"Transmogrify.pathname/1","type":"function"},{"doc":"See Transmogrify.Snakecase.convert/1 .","ref":"Transmogrify.html#snakecase/1","title":"Transmogrify.snakecase/1","type":"function"},{"doc":"See Transmogrify.Transmogrifier.transmogrify/2 .","ref":"Transmogrify.html#transmogrify/2","title":"Transmogrify.transmogrify/2","type":"function"},{"doc":"Polymorphic data transforms — accepts many input forms and tries to put them into the expected form. Easiest use: iex&gt; import Transmogrify.As iex&gt; as_int ( &quot;10&quot; ) { :ok , 10 } iex&gt; as_int! ( 10.0 ) 10","ref":"Transmogrify.As.html","title":"Transmogrify.As","type":"module"},{"doc":"Accept various data forms and assures they are atoms. WARNING: Make sure inputs being called are not using user-submitted data; or this may exhaust the atoms table. iex&gt; as_atom ( &quot;long ugly thing prolly&quot; ) { :ok , :&quot;long ugly thing prolly&quot; } iex&gt; as_atom ( &quot;as_atom&quot; ) { :ok , :as_atom } iex&gt; as_atom ( :atom ) { :ok , :atom } iex&gt; as_atom ( [ &quot;as_atom&quot; , &quot;another&quot; ] ) { :ok , [ :as_atom , :another ] } iex&gt; as_atom ( &#39;test&#39; ) { :ok , :test } iex&gt; as_atom ( :atom ) { :ok , :atom }","ref":"Transmogrify.As.html#as_atom/1","title":"Transmogrify.As.as_atom/1","type":"function"},{"doc":"Accept various data forms and assures they are atoms. WARNING: Make sure inputs being called are not using user-submitted data; or this may exhaust the atoms table. iex&gt; as_atom! ( &quot;long ugly thing prolly&quot; ) :&quot;long ugly thing prolly&quot; iex&gt; as_atom! ( &quot;as_atom&quot; ) :as_atom iex&gt; as_atom! ( :atom ) :atom iex&gt; as_atom! ( [ &quot;as_atom&quot; , &quot;another&quot; ] ) [ :as_atom , :another ] iex&gt; as_atom! ( &#39;test&#39; ) :test iex&gt; as_atom! ( :atom ) :atom iex&gt; as_atom! ( { :oops } ) ** (ArgumentError) argument error","ref":"Transmogrify.As.html#as_atom!/1","title":"Transmogrify.As.as_atom!/1","type":"function"},{"doc":"Accept various data forms and assures they are atoms (from the existing atoms table). See String.to_existing_atom/1 for more details. iex&gt; as_existing_atom ( &quot;long ugly thing prolly&quot; ) { :ok , :&quot;long ugly thing prolly&quot; } iex&gt; as_existing_atom ( &quot;non_existing_atom&quot; ) :error iex&gt; as_existing_atom ( &quot;as_existing_atom&quot; ) { :ok , :as_existing_atom } iex&gt; as_existing_atom ( :atom ) { :ok , :atom } iex&gt; as_existing_atom ( [ &quot;as_existing_atom&quot; , &quot;another&quot; ] ) { :ok , [ :as_existing_atom , :another ] } iex&gt; as_existing_atom ( :atom ) { :ok , :atom }","ref":"Transmogrify.As.html#as_existing_atom/1","title":"Transmogrify.As.as_existing_atom/1","type":"function"},{"doc":"Accept various data forms and assures they are atoms. WARNING: Make sure inputs being called are not using user-submitted data; or this may exhaust the atoms table. iex&gt; as_existing_atom! ( &quot;long ugly thing prolly&quot; ) :&quot;long ugly thing prolly&quot; iex&gt; as_existing_atom! ( &quot;as_existing_atom&quot; ) :as_existing_atom iex&gt; as_existing_atom! ( :atom ) :atom iex&gt; as_existing_atom! ( [ &quot;as_existing_atom&quot; , &quot;another&quot; ] ) [ :as_existing_atom , :another ] iex&gt; as_existing_atom! ( :atom ) :atom iex&gt; as_existing_atom! ( { :oops } ) ** (ArgumentError) argument error iex&gt; as_existing_atom! ( &quot;non_existing_atom&quot; ) ** (ArgumentError) argument error","ref":"Transmogrify.As.html#as_existing_atom!/1","title":"Transmogrify.As.as_existing_atom!/1","type":"function"},{"doc":"Accept strings, floats, and ints, and assure the result is either an float (parsed if necessary) or an error. iex&gt; as_float ( 10.52 ) { :ok , 10.52 } iex&gt; as_float ( 10 ) { :ok , 10.0 } iex&gt; as_float ( &quot;10.5&quot; ) { :ok , 10.5 } iex&gt; as_float ( &quot;.55&quot; ) { :ok , 0.55 } iex&gt; as_float ( &quot;tardis&quot; ) :error","ref":"Transmogrify.As.html#as_float/1","title":"Transmogrify.As.as_float/1","type":"function"},{"doc":"Accept strings, floats, and ints, and assure the result is either an float (parsed if necessary) or return the specified default (which is 0.0 if unspecified) iex&gt; as_float! ( 10.0 ) 10.0 iex&gt; as_float! ( 10 ) 10.0 iex&gt; as_float! ( &quot;10.0&quot; ) 10.0 iex&gt; as_float! ( &quot;tardis&quot; , 9.0 ) 9.0","ref":"Transmogrify.As.html#as_float!/2","title":"Transmogrify.As.as_float!/2","type":"function"},{"doc":"Accept strings, floats, and ints, and assure the result is either an int (parsed if necessary) or an error. iex&gt; as_int ( 10 ) { :ok , 10 } iex&gt; as_int ( 10.0 ) { :ok , 10 } iex&gt; as_int ( &quot;10&quot; ) { :ok , 10 } iex&gt; as_int ( &quot;tardis&quot; ) :error iex&gt; as_int ( :foo ) :error","ref":"Transmogrify.As.html#as_int/1","title":"Transmogrify.As.as_int/1","type":"function"},{"doc":"Accept strings, floats, and ints, and assure the result is either an int (parsed if necessary) or return the specified default (which is 0 if unspecified) iex&gt; as_int! ( 10 ) 10 iex&gt; as_int! ( 10.0 ) 10 iex&gt; as_int! ( &quot;10&quot; ) 10 iex&gt; as_int! ( &quot;tardis&quot; , 9 ) 9 iex&gt; as_int! ( :foo , 8 ) 8","ref":"Transmogrify.As.html#as_int!/2","title":"Transmogrify.As.as_int!/2","type":"function"},{"doc":"Accept atom or string. If string, run through snakecase and convert to atom. If atom, assume this is already done. iex&gt; as_key(&quot;thiskey&quot;) :thiskey iex&gt; as_key(&quot;this key&quot;) :&quot;this key&quot; iex&gt; as_key(:thisKey) :thisKey iex&gt; as_key(:this_key) :this_key","ref":"Transmogrify.As.html#as_key/1","title":"Transmogrify.As.as_key/1","type":"function"},{"doc":"Accept strings, floats, and ints, and assure the result is either a float or int (parsed if necessary) or an error. iex&gt; as_number ( 10.52 ) { :ok , 10.52 } iex&gt; as_number ( 10 ) { :ok , 10 } iex&gt; as_number ( &quot;10.5&quot; ) { :ok , 10.5 } iex&gt; as_number ( &quot;.55&quot; ) { :ok , 0.55 } iex&gt; as_number ( &quot;tardis&quot; ) :error","ref":"Transmogrify.As.html#as_number/1","title":"Transmogrify.As.as_number/1","type":"function"},{"doc":"Accept strings, floats, and ints, and assure the result is either a float or int (parsed if necessary) or return the specified default (which is 0 if unspecified) iex&gt; as_number! ( 10.0 ) 10.0 iex&gt; as_number! ( 10 ) 10 iex&gt; as_number! ( &quot;10.0&quot; ) 10.0 iex&gt; as_number! ( &quot;tardis&quot; , 9.0 ) 9.0","ref":"Transmogrify.As.html#as_number!/2","title":"Transmogrify.As.as_number!/2","type":"function"},{"doc":"Convert strings to CamelCase","ref":"Transmogrify.Camelcase.html","title":"Transmogrify.Camelcase","type":"module"},{"doc":"Convert a string to camelCase , usually when originally snake_case , using the following rules: ascii alphabetic letters immediately following an underscore are capitalized underscores are removed existing case and other characters are preserved in all other cases TODO: xref common feels around camelcase — spaces? other chars? iex&gt; convert ( &quot;_camel___case__&quot; ) &quot;camelCase&quot; iex&gt; convert ( &quot;camel_case&quot; ) &quot;camelCase&quot; iex&gt; convert ( &quot;camel_9case&quot; ) &quot;camel9case&quot; iex&gt; convert ( &quot;camel_case&quot; ) &quot;camelCase&quot; iex&gt; convert ( &quot;CamelCASE&quot; ) &quot;CamelCASE&quot; iex&gt; convert ( &quot;Camel_CASE&quot; ) &quot;CamelCASE&quot; iex&gt; convert ( &quot;CamelCase&quot; ) &quot;CamelCase&quot;","ref":"Transmogrify.Camelcase.html#convert/1","title":"Transmogrify.Camelcase.convert/1","type":"function"},{"doc":"Convert file/paths to Elixir ModuleName","ref":"Transmogrify.Modulename.html","title":"Transmogrify.Modulename","type":"module"},{"doc":"Convert a path/module_name/string to Elixir's Path.ModuleName.String , using the following rules similar to PascalCase: first letter is always capitalized ascii alphabetic letters immediately following an underscore are capitalized underscores are removed slashes are converted to dots existing case and other characters are preserved in all other cases iex&gt; convert ( &quot;MODULENAME&quot; ) &quot;MODULENAME&quot; iex&gt; convert ( &quot;_module___name__&quot; ) &quot;ModuleName&quot; iex&gt; convert ( &quot;module_name&quot; ) &quot;ModuleName&quot; iex&gt; convert ( &quot;module_name&quot; ) &quot;ModuleName&quot; iex&gt; convert ( &quot;module_name&quot; ) &quot;ModuleName&quot; iex&gt; convert ( &quot;ModuleNAME&quot; ) &quot;ModuleNAME&quot; iex&gt; convert ( &quot;Module_NAME&quot; ) &quot;ModuleNAME&quot; iex&gt; convert ( &quot;ModuleName&quot; ) &quot;ModuleName&quot; iex&gt; convert ( &quot;Module Name&quot; ) &quot;Module Name&quot; iex&gt; convert ( &quot;module/name/here&quot; ) &quot;Module.Name.Here&quot; iex&gt; convert ( &quot;module_9name.here&quot; ) &quot;Module9name.Here&quot; iex&gt; convert ( Module.Name ) &quot;Module.Name&quot; note: Original code from Macro.camelize/1 with minor changes: underscore followed by capital letter is treated the same as lowercase letter (the underscore is removed and the letter is capitalized) existing dots are treated the same as slashes (following letter is capitalized)","ref":"Transmogrify.Modulename.html#convert/1","title":"Transmogrify.Modulename.convert/1","type":"function"},{"doc":"Convert strings to PascalCase","ref":"Transmogrify.Pascalcase.html","title":"Transmogrify.Pascalcase","type":"module"},{"doc":"Convert a string to camelCase , usually when originally snake_case , using the following rules: first letter is always capitalized ascii alphabetic letters immediately following an underscore are capitalized underscores are removed existing case and other characters are preserved in all other cases iex&gt; convert ( &quot;PASCALCASE&quot; ) &quot;PASCALCASE&quot; iex&gt; convert ( &quot;_pascal___case__&quot; ) &quot;PascalCase&quot; iex&gt; convert ( &quot;pascal_case&quot; ) &quot;PascalCase&quot; iex&gt; convert ( &quot;pascal_case&quot; ) &quot;PascalCase&quot; iex&gt; convert ( &quot;PascalCASE&quot; ) &quot;PascalCASE&quot; iex&gt; convert ( &quot;Pascal_CASE&quot; ) &quot;PascalCASE&quot; iex&gt; convert ( &quot;PascalCase&quot; ) &quot;PascalCase&quot; iex&gt; convert ( &quot;pascal_9case&quot; ) &quot;Pascal9case&quot;","ref":"Transmogrify.Pascalcase.html#convert/1","title":"Transmogrify.Pascalcase.convert/1","type":"function"},{"doc":"Convert Elixir ModuleName to file/paths.","ref":"Transmogrify.Pathname.html","title":"Transmogrify.Pathname","type":"module"},{"doc":"Convert an Elixir's Path.ModuleName.String to path/module_name/string , using the following rules: PascalCase to snake_case rules apply dots are converted to slashes &quot;Elixir.&quot; prefix that exists on elixir module atoms is removed iex&gt; convert ( &quot;Module&quot; ) &quot;module&quot; iex&gt; convert ( &quot;ModuleName&quot; ) &quot;module_name&quot; iex&gt; convert ( &quot;MODULENAME&quot; ) &quot;modulename&quot; iex&gt; convert ( &quot;ModuleName&quot; ) &quot;module_name&quot; iex&gt; convert ( &quot;ModuleName.Here&quot; ) &quot;module_name/here&quot; iex&gt; convert ( &quot;path/name/here&quot; ) &quot;path/name/here&quot; iex&gt; convert ( Transmogrify.Pathname ) &quot;transmogrify/pathname&quot; iex&gt; convert ( &quot;A.AcronymNAME&quot; ) &quot;a/acronym_name&quot; note: Original code from Macro.underscore()","ref":"Transmogrify.Pathname.html#convert/1","title":"Transmogrify.Pathname.convert/1","type":"function"},{"doc":"Convert strings to snake_case","ref":"Transmogrify.Snakecase.html","title":"Transmogrify.Snakecase","type":"module"},{"doc":"Convert a string to snake_case , usually when originally PascalCase or CamelCase , using the following rules: dashes are treated the same as underscores uppercase ascii alphabetic letters are lowercased, and prefixed with an underscore, except when they are the first letter. duplicate underscores are removed ACRONYMS are preserved other characters are preserved in all other cases Similar to Pathname, except . is not converted to / , and dashes are coverted to underbars iex&gt; convert ( &quot;value-dashed&quot; ) &quot;value_dashed&quot; iex&gt; convert ( &quot;Value&quot; ) &quot;value&quot; iex&gt; convert ( &quot;vaLue&quot; ) &quot;va_lue&quot; iex&gt; convert ( &quot;VALUE&quot; ) &quot;value&quot; iex&gt; convert ( &quot;vaLUE&quot; ) &quot;va_lue&quot; iex&gt; convert ( &quot;-vaLUE&quot; ) &quot;va_lue&quot; iex&gt; convert ( &quot;_va___LUE&quot; ) &quot;va_lue&quot;","ref":"Transmogrify.Snakecase.html#convert/1","title":"Transmogrify.Snakecase.convert/1","type":"function"},{"doc":"Convert keys and values in maps and lists of maps","ref":"Transmogrify.Transmogrifier.html","title":"Transmogrify.Transmogrifier","type":"module"},{"doc":"Primary function for transmogrifying maps and lists of data that may include maps. Options key_convert: — convert types on keys in maps :none | nil (default) — do not convert key types :atom — make all binary/string keys into atoms :semi_atom - make binary/string keys starting with : into atoms :string — make all keys into binary/strings value_convert: — convert types on values in maps :none | nil (default) — do not convert key types :atom — make all binary/string keys into atoms :semi_atom - make binary/string keys starting with : into atoms :string — make all keys into binary/strings key_case: — convert case on keys in maps nil (default) — do not alter case :snake — convert keys into snake_case :camel — convert keys into camelCase :pascal — convert keys into PascalCase value_case: — convert case on values in maps nil (default) — do not alter case :snake — convert keys into snake_case :camel — convert keys into camelCase :pascal — convert keys into PascalCase deep: false | true (default) — recurse full depth of maps/lists or not clean_nil: false (default) | true — remove list/map entry if value is nil clean_empty_list: false (default) | true — remove list/map entry if zero-length list clean_empty_string: false (default) | true — remove list/map entry if zero-length string Examples iex&gt; transmogrify ( %{ &quot;Tardis&quot; =&gt; %{ &quot;Key&quot; =&gt; 10 } , &quot;is&quot; =&gt; 2 , &quot;The.Color&quot; =&gt; &quot;blue&quot; } , key_convert : :atom ) %{ Tardis : %{ Key : 10 } , is : 2 , &quot;The.Color&quot; : &quot;blue&quot; } iex&gt; transmogrify ( %{ &quot;Tardis&quot; =&gt; %{ &quot;Key&quot; =&gt; 10 } , &quot;is&quot; =&gt; 2 , &quot;The.Color&quot; =&gt; &quot;blue&quot; } , key_convert : :atom , deep : false ) %{ Tardis : %{ &quot;Key&quot; =&gt; 10 } , is : 2 , &quot;The.Color&quot; : &quot;blue&quot; } iex&gt; transmogrify ( %{ &quot;Sonic&quot; =&gt; 1 , &quot;ScrewDriver&quot; =&gt; &quot;:thIrd&quot; } , key_convert : :atom , key_case : :snake , value_convert : :atom , value_case : :snake ) %{ sonic : 1 , screw_driver : :th_ird } iex&gt; transmogrify ( [ %{ :thisCase =&gt; 1 , &quot;thatCase&quot; =&gt; 2 } ] , key_case : :snake , key_convert : :none ) [ %{ :this_case =&gt; 1 , &quot;that_case&quot; =&gt; 2 } ] iex&gt; transmogrify ( [ %{ :this_case =&gt; 1 , &quot;that_case&quot; =&gt; 2 } ] , key_case : :camel , key_convert : :none ) [ %{ :thisCase =&gt; 1 , &quot;thatCase&quot; =&gt; 2 } ] iex&gt; transmogrify ( [ ...&gt; %{ a : 1 , ...&gt; b : [ &quot;red&quot; , nil , &quot;&quot; , [ ] , &quot;:green&quot; ] , ...&gt; c : [ ] , d : nil , e : &quot;&quot; , ...&gt; f : %{ TarVis : &quot;blue&quot; } , ...&gt; j : &quot;:sonic&quot; } ...&gt; ] , ...&gt; key_case : :snake , key_convert : :atom , ...&gt; value_case : :snake , value_convert : :none , ...&gt; clean_nil : true , clean_empty_list : true , clean_empty_string : true ...&gt; ) [ %{ a : 1 , b : [ &quot;red&quot; , &quot;:green&quot; ] , f : %{ tar_vis : &quot;blue&quot; } , j : &quot;:sonic&quot; } ] iex&gt; transmogrify ( [ ...&gt; %{ a : 1 , ...&gt; b : [ &quot;red&quot; , nil , &quot;&quot; , [ ] , &quot;:green&quot; ] , ...&gt; c : [ ] , d : nil , e : &quot;&quot; , ...&gt; f : %{ TarDis : &quot;blue&quot; } , ...&gt; j : &quot;:sonic&quot; } , 10 ...&gt; ] , ...&gt; value_convert : :semi_atom ...&gt; ) [ %{ a : 1 , b : [ &quot;red&quot; , nil , &quot;&quot; , [ ] , :green ] , f : %{ TarDis : &quot;blue&quot; } , j : :sonic , c : [ ] , d : nil , e : &quot;&quot; } , 10 ] iex&gt; transmogrify ( %{ key1 : 10 , keyTwo : &quot;foo&quot; } , key_convert : :string ) %{ &quot;key1&quot; =&gt; 10 , &quot;keyTwo&quot; =&gt; &quot;foo&quot; } iex&gt; transmogrify ( %{ key1 : 10 , keyTwo : &quot;foo&quot; } , key_convert : :string , key_case : :snake ) %{ &quot;key1&quot; =&gt; 10 , &quot;key_two&quot; =&gt; &quot;foo&quot; }","ref":"Transmogrify.Transmogrifier.html#transmogrify/2","title":"Transmogrify.Transmogrifier.transmogrify/2","type":"function"},{"doc":"Elixir module which accepts data with different shapes and changes them to an expected shape, such as switching keys in a map to camel case, or all string keys to atom keys, etc. Full docs found at: https://hexdocs.pm/transmogrify .","ref":"readme.html","title":"Transmogrify","type":"extras"},{"doc":"The package can be installed by adding transmogrify to your list of dependencies in mix.exs : def deps do [ { :transmogrify , &quot;~&gt; 1.1.0&quot; } ] end","ref":"readme.html#installation","title":"Transmogrify - Installation","type":"extras"}]